/*
  SOLID - Software Library for Interference Detection
  Copyright (C) 1997-1998  Gino van den Bergen

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA.

  Please send remarks, questions and bug reports to gino@win.tue.nl,
  or write to:
                  Gino van den Bergen
		  Department of Mathematics and Computing Science
		  Eindhoven University of Technology
		  P.O. Box 513, 5600 MB Eindhoven, The Netherlands
*/

#ifdef _MSC_VER
#pragma warning(disable:4786) // identifier was truncated to '255'
#pragma warning(disable:4996) // std::_Copy_opt was declared as disaproved because unsafe
#endif // _MSC_VER

#include "Polygon.h"

Point Polygon::support(const Vector& v) const {
  Scalar h = dot((*this)[ci], v), d;
  int ni = ci < numVerts()-1 ? ci+1 : 0;
  if ((d = dot((*this)[ni], v)) > h) { 
    do { 
      h = d; ci = ni;
      if (++ni == numVerts()) ni = 0;
    }
    while ((d = dot((*this)[ni], v)) > h);
  }
  else {
    ni = ci ? ci-1 : numVerts()-1;
    while ((d = dot((*this)[ni], v)) > h) {
      h = d; ci = ni;
      if (ni) --ni; else ni = numVerts()-1;
    }
  }  
  return (*this)[ci];
}





